macroScript Corona_tweaks category:"Corona Renderer" 
buttontext:"Corona Tools"  toolTip:"Corona Renderer tweaker"
(
try (cui.UnRegisterDialogBar Corona_tweaker) catch()
try (cui.FloatDialogBar Corona_tweaker) catch()
try (destroydialog Corona_tweaker) catch()
Rollout Corona_tweaker "CoronaRndTweaker"	
(
GroupBox grp1 "--Mat.Editor Settings" pos:[2,0] width:120 height:238

	spinner dll "LimitDiff:"  pos:(grp1.pos+[19,20]) width:65 height:16 range:[0.00,1,1] type:#float 
		tooltip:"Set global upper limit of diffuse level of all scene materials"
	button dllb "push"  pos:(grp1.pos+[87,18]) width:29 height:20 	
		on dllb pressed do
			for i in getclassinstances coronamtl do
			( if i.leveldiffuse > dll.value then i.leveldiffuse = dll.value )	
			
	spinner tbs "BitmpBlr:"  pos:(grp1.pos+[19,45]) width:65 height:16 range:[0.01,1,1] type:#float
		tooltip:"Set global blur for all bitmaps in scene"
	button tbsb "push"  pos:(grp1.pos+[87,43]) width:29 height:20 
	on tbsb pressed do
		for mp in getClassInstances Bitmaptexture do 
			( 	mp.coords.blur = tbs.value 
				mp.filtering = 0 )
		--for i in getclassinstances CoronaMtl do
			--(	i i.texmapBump = 0.1  	)
	
	checkbutton ShowHideMaps "ShowMaps" checked:false pos:(grp1.pos+[11,70]) width:55 height:20 tooltip:"Show/Hide maps in viewport"
		on ShowHideMaps changed state do
		( 	if state == on then (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse on) catch())
			else (for i in getclassinstances CoronaMtl do
					try (showTextureMap i i.texmapDiffuse off) catch()) 	)			
	
	button SceneMaterials2MaterialEditor "SM2ME" pos:(grp1.pos+[71,70]) width:45 height:20 enabled:true
		tooltip:"Clear material editor and move all scene materials to material editor"	
	on SceneMaterials2MaterialEditor pressed do
	(
	i=0
	while i< 24 do(
		i=i+1
		meditMaterials[i]=CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	
		--for i in getclassinstances coronamtl do
		--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )
	)

	i=0
	numberOfMaterials = sceneMaterials.count
	if numberOfMaterials > 24 then numberOfMaterials = 24

	while i< numberOfMaterials do(
		i=i+1
		meditMaterials[i]=sceneMaterials[i]
	)
)	
					
	button btnResetMtlEdit "M.E.>CoronaMtl" width:100 height:20
		tooltip:"Clean material Editor with default white CoronaMaterials"		
	on btnResetMtlEdit pressed do
		try (
			(   for i = 1 to 24 do  
			(meditMaterials[i] = CoronaMtl name:("CoronaMtl - " + (formattedPrint i format:".2d"))	)
			--for i in getclassinstances coronamtl do
			--( 	i.leveldiffuse=0.8; i.colordiffuse=color 220 220 220  )					
			)
			) catch()
	
	button CConverter "Corona Converter" width:100 height:20
		tooltip:"Convert scene to Corona materials/lights"	
	on CConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaConverter_v1.22.ms")	
				
	checkbox Displacecb "Displacement" width:100 height:16 checked:true 
		on Displacecb changed state do try (
		( 	renderDisplacements = state
		renderSceneDialog.update() 	)	) catch()
				
	checkbox Mtl_override "Mtl.override" width:100 height:16  
		on Mtl_override changed state do try (
		( 	renderers.current.mtlOverride_enabled = state
		 	)	) catch()
	
	button CLL "Corona Light Lister" width:100 height:20 tooltip:"download and install it from http://corona-lightlister.com to work"
		tooltip:"Display scene lights properties"	
	on CLL pressed do
			(actionMan.executeAction 13911 "7564")

	button CIes "Corona Ies Presets" width:100 height:20
		tooltip:"Ies manager"	
	on CIes pressed do
			(filein "$scripts\CoronaRenderer\CoronaIesPresets v1.02.ms")			
		
	--------------------------------------------------------------------

	GroupBox gCproxy "Proxy/Scatter Settings" pos:(grp1.pos+[0,241]) width:120 height:68
	
	button V2CPConverter "Vray->Corona Proxy" pos:(gCproxy.pos+[3,18]) width:114 height:20
		tooltip:"Vray to Corona Proxy Converter"	
	on V2CPConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaConvertProxies.ms")
	
	button V2CSConverter "Vray->Corona Scatter" pos:(gCproxy.pos+[3,42]) width:114 height:20
		tooltip:"Vray to Corona Scatter Converter"	
	on V2CSConverter pressed do
			(filein "$scripts\CoronaRenderer\coronaScatterConverter_v0.03.ms")
	
	GroupBox grp2 "Render Setup Settings" pos:(gCproxy.pos+[0,70]) width:120 height:634
			 			
	spinner giaa "GI/AA bal.:" range:[1,286,16] width:78 type:#integer align:#right pos:(grp2.pos+[32,18])
		tooltip:"GI vs. AA balance"
		on giaa changed val do
			try ( (renderers.current.shading_giToAaRatio = giaa.value) ) catch()	
				
	spinner msi "M.S.I.:"  range:[0,1000,20] width:63 type:#integer align:#right
		tooltip:"Max Sample Intensity"
		on msi changed val do
			try ( (	renderers.current.shading_maxSampleIntensity = msi.value	)  ) catch()
			
	spinner lightsmpls "Light Samples:"  width:90 range:[0,100,2] type:#float align:#right
		tooltip:"Light Samples Multiplier"
		on lightsmpls changed val do
			try ( (renderers.current.lights_samplesMult = lightsmpls.value) ) catch()
	
	spinner passlim "Pass limit:" range:[0,10000,100] width:73 type:#integer align:#right
		on passlim changed val do
			try ( (renderers.current.progressive_passLimit = passlim.value) ) catch()
	
	label TimeLimlbl "Time limit [hh:mm:ss]:" 
	spinner TimeLimH "h" pos:(grp2.pos+[7,120]) width:32 range:[0,100,0] type:#integer tooltip:"hours"
	spinner TimeLimM "m" pos:(grp2.pos+[45,120]) width:35 range:[0,59,0] type:#integer tooltip:"minutes" 
	spinner TimeLimS "s" pos:(grp2.pos+[84,120]) width:34 range:[0,59,0] type:#integer tooltip:"seconds"
		on TimeLimH changed val do 	try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value+1000*TimeLimS.value) 
			) catch()
		on TimeLimM changed val do try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value+1000*TimeLimS.value) 
			) catch()
		on TimeLimS changed val do 	try ( 
			(renderers.current.progressive_timeLimit = 3600000*TimeLimH.value+60000*TimeLimM.value+1000*TimeLimS.value)
			) catch()
				
	dropdownList tvfb "       VFB type:"   tooltip:"Choose Type of VFBuffer"
		items:#("Native 3dsmax VFB", "Corona VFB","None" )
		on tvfb selected sel do try (
		(   case tvfb.selection of
			(	1: ( renderers.current.vfb_type = 1 )
				2: ( renderers.current.vfb_type = 2 )
				3: ( renderers.current.vfb_type = 0 )	  )			
	   	)
		) catch()
	
	dropdownList imfilter "     Image filter:"   tooltip:"Choose Type of Image filter"
		items:#("Box","Gaussian","Tent","None" )	
		on imfilter selected sell do try (
		(   case imfilter.selection of
			(	1: ( renderers.current.image_filter_type = 1 )
				2: ( renderers.current.image_filter_type = 2 )
				3: ( renderers.current.image_filter_type = 3 )
				4: ( renderers.current.image_filter_type = 0 )	  )
		)
		) catch()
	
	spinner Exposure "Exposure:"  width:80 height:16 range:[-20,20,2] type:#float align:#right
		tooltip:"Exposure (EV)"
		on Exposure changed val do try (
			(renderers.current.colorMap_simpleExposure = Exposure.value) ) catch() 
	
	spinner Contast "Contrast:"  width:80 height:16 range:[1,20,1] type:#float align:#right
		on Contast changed val do try (
			(renderers.current.colorMap_contrast = Contast.value) 	) catch()
			
	spinner HLCompr "HighLight:"  width:80 height:16 range:[0.01,20,2] type:#float align:#right
		tooltip:"HighLight compress"
		on HLCompr changed val do try (
			(renderers.current.colorMap_highlightCompression = HLCompr.value)	) catch()

	spinner WBlnce "WhiteBl[K]:"  width:98 height:16 type:#integer align:#right 
		range:[1800,11000,6500] tooltip:"White balance [K]"
		on WBlnce changed val do try (
			(renderers.current.colorMap_colorTemp = WBlnce.value)	) catch()	
			
	spinner gamma "*Gamma:" width:80 range:[-3.0,3.0,2.2] type:#float align:#right
		tooltip:"*works with CoronaVFB only"
		on gamma changed val do try (
			(renderers.current.colormap_additionalGamma = gamma.value-2.2 ) ) catch()
	
	checkbutton ShowCrnVfb "Corona VFB sh/h " checked:false width:100 height:20 tooltip:"CoronaVFB show(pressed)/hide(unpressed)"
		on ShowCrnVfb changed state do
		(	if state == on then CoronaRenderer.CoronaFp.showVfb true
			else CoronaRenderer.CoronaFp.showVfb false 	)		
	
	button Renderrun "Render Scene F9" checked:false width:100 height:20 
		on Renderrun pressed do 
		(CoronaRenderer.CoronaFp.setDisplayedChannel 0	
		( max quick render ))
	
	button startIR "Start Interactive"  width:100 height:20 tooltip:"Start Interactive Render"
		on startIR pressed do try (
			 ( CoronaRenderer.CoronaFp.setDisplayedChannel 0
				 CoronaRenderer.CoronaFp.startInteractive() ) ) catch()
			 
	button rlrb "Resume Render" width:100 height:20 tooltip:"Resume Last Render"
		on rlrb pressed do
			( CoronaRenderer.CoronaFp.setDisplayedChannel 0
				coronarenderer.resumeRender() )		
	
	checkbutton Renderview "RegionRnr On/Off" checked:false width:100 height:20 tooltip:"Region Render On(pressed)/Off(unpressed)"
		on Renderview changed state do
		( 	if state == on then 
					( setRenderType #region; EditRenderRegion.EditRegion() )
			else 	( EditRenderRegion.EditRegion() false; setRenderType #view )
		)
	
	button rs "RenderSelection" width:100 height:20 tooltip:"Render Selected objects" enabled:true
		on rs pressed do
		(
		r=renderers.current.renderSelected_mode as integer
		renderers.current.renderSelected_mode=1
		CoronaRenderer.CoronaFp.setDisplayedChannel 0
		max quick render
		renderers.current.renderSelected_mode=r
		)
	
	button RSmask "RenderSelectionMask" width:110 height:20 tooltip:"Render quick mask from selection"	
			on RSmask pressed do
			(filein "$scripts\CoronaRenderer\corona-quickMask.ms")			
	
	button Panarama_Exporter "Panarama Exporter" width:100 height:20
		on Panarama_Exporter pressed do
		(filein "$scripts\CoronaRenderer\PanoramaExporter_v0.3.ms")
		
	spinner passLimit "Pass Limit:"   range:[0,10000,0] width:80 type:#integer align:#right
		on passLimit changed val do try (
			(renderers.current.interactive_passLimit = passLimit.value)	 ) catch()
			
	spinner numThreads "Numb.threads:"   range:[-100,100,-1] width:80 type:#integer align:#right
		on numThreads changed val do try (
			(renderers.current.interactive_numThreads = numThreads.value)	 ) catch()
	
	on Corona_tweaker open do
		(	
			try (
			displacecb.state = renderDisplacements;
		 	Mtl_override.state = renderers.current.mtlOverride_enabled;
			giaa.value =  renderers.current.shading_giToAaRatio;
			msi.value = renderers.current.shading_maxSampleIntensity;
			lightsmpls.value = renderers.current.lights_samplesMult;
			passlim.value = renderers.current.progressive_passLimit;
			tvfb.selection = renderers.current.vfb_type;
			imfilter.selection = renderers.current.image_filter_type;
			Exposure.value = renderers.current.colorMap_simpleExposure;
			Contast.value = renderers.current.colorMap_contrast;
			HLCompr.value = renderers.current.colorMap_highlightCompression;
			WBlnce.value = renderers.current.colorMap_colorTemp;
			gamma.value = 2.2+renderers.current.colormap_additionalGamma;
			numThreads.value = renderers.current.interactive_numThreads;
			passLimit.value = renderers.current.interactive_passLimit;
			TimeLimH.value = renderers.current.progressive_timeLimit/3600000;
			TimeLimM.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000)/60000; 
			TimeLimS.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000 - TimeLimM.value*60000)/1000
			BitmapProxyMgr.globalProxyEnable = false;
			IBitmapPager.enabled = false 
			)
			catch()
		)  
						
		on Corona_tweaker mousemove pos do --lbuttondown 
		(	
			try (
			displacecb.state = renderDisplacements;
		 	Mtl_override.state = renderers.current.mtlOverride_enabled;	
			giaa.value =  renderers.current.shading_giToAaRatio;
			msi.value = renderers.current.shading_maxSampleIntensity;
			lightsmpls.value = renderers.current.lights_samplesMult;
			passlim.value = renderers.current.progressive_passLimit;
			tvfb.selection = renderers.current.vfb_type;
			imfilter.selection = renderers.current.image_filter_type;
			Exposure.value = renderers.current.colorMap_simpleExposure;
			Contast.value = renderers.current.colorMap_contrast;
			HLCompr.value = renderers.current.colorMap_highlightCompression;
			WBlnce.value = renderers.current.colorMap_colorTemp;
			gamma.value = 2.2+renderers.current.colormap_additionalGamma;
			numThreads.value = renderers.current.interactive_numThreads;
			passLimit.value = renderers.current.interactive_passLimit;
			TimeLimH.value = renderers.current.progressive_timeLimit/3600000;
			TimeLimM.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000)/60000; 
			TimeLimS.value = (renderers.current.progressive_timeLimit - TimeLimH.value*3600000 - TimeLimM.value*60000)/1000
			 )
			catch()	
		)
		
	button ascrb "Assign CoronaRn." width:100 height:20 --color:(color 255 0 0)
		tooltip:"set Assign Renderer to Corona with saved all settings of previous renderer"
		on ascrb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\PreviousRndrStngs.rps");
			renderers.production = CoronaRenderer() 
		)
		
	button rsb "Reset Corona" width:100 height:20 
		tooltip:"set Assign Renderer to Def.Scanlline and then return to Corona with saved all settings"
		on rsb pressed do 
		(
			renderpresets.SaveAll 0 (GetDir #renderPresets + "\\coronareset.rps");
			renderers.production = Default_Scanline_Renderer();
			renderers.production = CoronaRenderer(); 
			renderpresets.LoadAll 0 (GetDir #renderPresets + "\\coronareset.rps")
		)
		
	button OpenF10 "Open F10" width:100 height:20 tooltip:"Open Render Setap dialog (F10)"
		on OpenF10 pressed do
		( if renderSceneDialog.isOpen()==true then renderSceneDialog.Close() 
			else renderSceneDialog.Open() 		)
			
	label lbl3 "for v.1.xx.xx 05.03.15" pos:(OpenF10.pos+[-8,30]) align:#center 
	label lbl2 " headoff, 2015"
	label lbl4 "archdizs@gmail.com"
	hyperlink coronawww "Corona-renderer.com" address:"https://corona-renderer.com/" visitedColor:(color 255 0 0) color:(color 255 0 0) align:#center
)
createdialog Corona_tweaker pos:[0,126] width:125 --menu:<RCMenu>
cui.RegisterDialogBar Corona_tweaker style:#(#cui_dock_left, #cui_dock_right, #cui_floatable, #cui_handles)
cui.DockDialogBar Corona_tweaker #cui_dock_left
--cui.FloatDialogBar Corona_tweaker
)